void response(float **R, float Cq[], float Cm[], float Br[], float Bt[], float Bp[],float lev,
              float I[], float Q[], float U[], float V[],
              int ngrid, int nobs, spec_info_t spec_info[], spec_sample_t sampling,
              int imsw[], int magnetic, int calc_all, int calc_quasi);

void mk_image(float Cq[], float Cm[], float Br[], float Bt[], float Bp[],
              int ngrid, float lev, float image[], int imsw[]);

void cp_image(float Cq[], float Cm[], float Br[], float Bt[], float Bp[],
              int ngrid, float *lev, float image[], int imsw[]);

void mk_data(float I[], float Q[], float U[], float V[],
             spec_info_t spec_info[], int nobs, float data[]);

void cp_data(float I[], float Q[], float U[], float V[],
             spec_info_t spec_info[], int nobs, float data[]);

void mk_sigma(spec_info_t spec_info[], int nobs, float sig2[]);

void modify_response(float **R, float data[], float odata[],
                     spec_info_t spec_info[], int nobs, float cont[],
		     float dcont[], int imsw[], float Cq[], float Cm[],float lev,
		     int ngrid, int magnetic);

void unmodify_response(float **R, float odata[],
                       spec_info_t spec_info[], int nobs, float cont[],
		       float dcont[], int imsw[], int ngrid);

void update_data(float **R, int rows, int cols, float image[], float data[], float off[]);


static void doppl_deriv(float ***dSks, float I[], float Q[], float U[], 
                        float V[], spec_info_t spec_info, spec_sample_t sampling, double Cq, 
                        double Cm, double B, double gamma, double chi, double mu, double vel,
                        int imsw[], int magnetic);

static void find_derivs_to_smear(int imsw[], int mod_imsw[], int magnetic);

static void contin_derivs(spec_info_t spec_info[], int nobs, float cont[],
	       float dcont[], int imsw[], float Cq[], float Cm[], int ngrid, int magnetic);

