void geometry(double phase, int n, cell_info_t geom[],
              int magnetic, float Br[], float Bt[], float Bp[],
              float B[], float gamma[], float chi[], cell_deriv_t derivs[]);
void areas(int ngrid, float area[]);
void locations(double phase, int ngrid, float theta[], float phi[]);
void find_grid_loc(double theta, double phi, int *n, double phase);
void init_grid(int ngrid, double inc, double ve);
void set_polaroid(double angle);
void init_diffrot(int batch); 
void legendre(float ***L, int ngrid, int lmax, int potential, float alpha); 

static int sum_cells(int ring, double inc);
static int opt_ring(int ngrid, int lring, int uring, double inc);

