int main(int argc, char *argv[]);

void check_available_lines(spec_info_t spec_info[], int nobs, char *line_names[],
                           int line_ids[], int nlines, int line_used[]);

void get_lines_to_fit(spec_info_t spec_info[], int nobs, char *line_names[],
		                 int line_used[], int nlines, int batch);

void get_stokes_params_to_fit(spec_info_t spec_info[], int nobs, int datsw[], int batch);

static void set_pixel_weights(float w[], int weight, int ngrid, int n_image);

int get_photometry_info(spec_info_t *spec_info, int nobs, float *mag0, float *wphot,
                        int batch);

void calc_spot(float *Cq, float *Br, float *Bp, float *Bt, int ngrid,
               int *imsw, float *area, float *phi, float *the, int ff_entropy,
               float *spot, float *spot_loc, float phimin, float phimax); 

